;------------------------------------------------------------
; AZuIvV
;------------------------------------------------------------
VX4:	EQU	1	;VX-4
VX3:	EQU	2	;VX-3
MODEL:	EQU	VX4

#if MODEL=VX4
;------------------------------------------------------------
; WORK AREA
;------------------------------------------------------------
EDCSR:	EQU	&H1101	;J[\ʒu
FDDBF:	EQU	&H1793	;FDDo̓obt@
MEMEN:	EQU	&H18CF	;t[GA擪|C^
DIREN:	EQU	&H18D1	;RAM(DIR)ŏI|C^
CALC:	EQU	&H18D3	;CALCpobt@
SSPTP:	EQU	&H1BD7	;VXeX^bN擪
USPTP:	EQU	&H1CD0	;[U[X^bN擪
DEFDIR:	EQU	&H2FFF	;DIRENl

;------------------------------------------------------------
; BIOS Routine
;------------------------------------------------------------
CHEX1:	EQU	&H009D	;16i-->oCiϊ
CROFF:	EQU	&H032E	;J[\OFF(KYIÑJ[\\OFFɂ)
KYIN:	EQU	&H03A4	;WL[͏i$0ɓ͂ꂽL[R[hj
FREE:	EQU	&H20E2	;FREEGAeʂ\
CLS:	EQU	&H2ADF	;ʏ(PRINT CHR$(12)Ɠ)
OUTAC:	EQU	&H2AF1	;1\(o͐OUTDVɂĎw)
USER:	EQU	&H52FF	;$15,$16̎BANK1̃[`R[BANK1ɖ߂
BIOS:	EQU	&H5321	;BIOS(BANK0)R[BANK1ɖ߂
INZFCOM:EQU	&H6683	;F.COMp[^

;------------------------------------------------------------
; User Routine
;------------------------------------------------------------
PBF2BIN:EQU	FDDBF	;PBFt@C[_[
RCS:	EQU	&H187B	;BIOSĂяo

#else
;------------------------------------------------------------
; WORK AREA
;------------------------------------------------------------
EDCSR:	EQU	&H6101	;J[\ʒu
FDDBF:	EQU	&H678C	;FDDo̓obt@
MEMEN:	EQU	&H68C8	;t[GA擪|C^
DIREN:	EQU	&H68CA	;RAM(DIR)ŏI|C^
CALC:	EQU	&H68CC	;CALCpobt@
SSPTP:	EQU	&H6BD0	;VXeX^bN擪(e탏[NƂėp)
USPTP:	EQU	&H6CD0	;[U[X^bN擪
DEFDIR:	EQU	&H7FFF	;DIRENl

;------------------------------------------------------------
; BIOS Routine
;------------------------------------------------------------
CHEX1:	EQU	&H0125	;16i-->oCiϊ
KYIN:	EQU	&H03D1	;WL[͏i$0ɓ͂ꂽL[R[hj
CROFF:	EQU	&H1FAE	;J[\ON(KYIÑJ[\\OFFɂ)
FREE:	EQU	&H2858	;FREEGAeʂ\
CLS:	EQU	&H31CF	;ʏ(PRINT CHR$(12)Ɠ)
OUTAC:	EQU	&H31E1	;$161\(o͐OUTDVɂĎw)
USER:	EQU	&H5C85	;$15,$16̎BANK1̃[`R[BANK1ɖ߂
BIOS:	EQU	&H5CA7	;BIOS(BANK0)R[BANK1ɖ߂
INZFCOM:EQU	&H6FAA	;F.COMp[^

;------------------------------------------------------------
; User Routine
;------------------------------------------------------------
PBF2BIN:EQU	FDDBF	;PBFt@C[_[
RCS:	EQU	&H687B	;BIOSĂяo
#endif

	ORG	CALC
	START	INIT

#if MODEL=VX4
	DB	"MODE110(6369)",0	;CALCL[͕
#else
	DB	"MODE110(26843)",0	;CALCL[͕
#endif

INIT:	LDW	$28,CLS		;ʏ
	CAL	RCS		;

	PRE	SS,SSPTP	;VXeX^bN|C^
	PRE	US,USPTP	;[U[X^bN|C^

	LDW	$28,INZFCOM	;샂[hF.COMɐݒ
	CAL	RCS		;

	LDW	$22,DIREN	;$22,$23 = DIREN
	LDW	$24,DEFDIR	;$24,$25 = (DIRENl)

MENU:	PRE	IZ,MSG00	;
	LD	$0,11		;MENUʕ\
	CAL	PRLB1		;

	LDW	$0,EDCSR	;
	ST	89,($0)		;
	LDW	$28,FREE	;t[GA\
	CAL	RCS		;

KEYIN:	CAL	@KYIN

	SBC	$0,"R"		;oCit@Cs
	JR	Z,RUN		;
	SBC	$0,"N"		;oCit@C폜
	JR	Z,NEW		;
	SBC	$0,"L"		;oCit@C[h
	JR	NZ,KEYIN	;

	PRE	IZ,MSG01	;"loading pbf."\
	CAL	PRLB4		;

	CAL	PBF2BIN		;PBFt@C[h

	LDW	$0,MSG00 + 14	;"*"\
	ST	"*",($0)	;
	JR	MENU
;
;	oCit@Cs
;
RUN:	PRE	IX,$22		;
	SBCW	(IX+$31),$24	;oCit@C̗L`FbN
	JR	Z,KEYIN		;

	LDW	$15,JPTBL	;
	LDW	$28,USER	;oCit@Cs
	CAL	RCS		;
	JR	INIT
;
;	oCit@C폜
;
NEW:	PRE	IZ,MSG02	;"New (Y/N) ? "\
	CAL	PRLB4		;

	CAL	@KYIN		;
	SBC	$0,"Y"		;NoȂMENUɖ߂
	JR	NZ,MENU		;

	LDW	$0,MSG00 + 14	;"*"
	ST	"0",($0)	;

	STW	$24,($22),MENU	;DIRENZbg

;------------------------------------------------------------
; L[ J[\It
; o $0
;------------------------------------------------------------
@KYIN:	LDW	$28,CROFF	;J[\It
	CAL	RCS		;
	LDW	$28,KYIN	;L[
	JP	RCS

;------------------------------------------------------------
; 4sڂɕ\ Nullǂݍ񂾂I
;  IZ (̊i[AhX)
;------------------------------------------------------------
PRLB4:	LD	$0,99

;------------------------------------------------------------
; \ Nullǂݍ񂾂I
;  IZ (̊i[AhX),$0 (J[\ʒu)
;------------------------------------------------------------
PRLB1:	PRE	IX,EDCSR	;J[\ʒuݒ
	ST	$0,(IX+$31)	;
PRL01:	LDI	$16,(IZ+$31)	;f[^ǂݍ
	SBC	$16,$31		;Null`FbN
	RTN	Z		;
	LDW	$28,OUTAC	;1\
	CAL	RCS		;
	JR	PRL01

;------------------------------------------------------------
; \
;------------------------------------------------------------
MSG00:  DB      "< BINARY >",&H0D,&H0D,"M 0",&H0D
        DB	"M0>Run/Load/New ",0
MSG01:	DB	"loading pbf.",0
MSG02:	DB	"New (Y/N) ? ",0
;------------------------------------------------------------
; JUMPe[u
;------------------------------------------------------------
JPTBL:	DB	&H37,0,0
